import{S as qp,i as Rp,s as Cp,e as o,k as c,w as g,t as l,M as Up,c as r,d as t,m,a as n,x as $,h as p,b as u,N as Op,G as a,g as h,y as v,q as b,o as w,B as E,v as Mp,L as ha}from"../../chunks/vendor-hf-doc-builder.js";import{T as Tp}from"../../chunks/Tip-hf-doc-builder.js";import{I as M}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as Lp}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";import{F as zi,M as fa}from"../../chunks/Markdown-hf-doc-builder.js";function zp(A){let f,_,i,d,k;return{c(){f=o("p"),_=l("DreamBooth finetuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),i=o("a"),d=l("in-depth analysis"),k=l(" with recommended settings for different subjects to help you choose the appropriate hyperparameters."),this.h()},l(j){f=r(j,"P",{});var I=n(f);_=p(I,"DreamBooth finetuning is very sensitive to hyperparameters and easy to overfit. We recommend you take a look at our "),i=r(I,"A",{href:!0,rel:!0});var C=n(i);d=p(C,"in-depth analysis"),C.forEach(t),k=p(I," with recommended settings for different subjects to help you choose the appropriate hyperparameters."),I.forEach(t),this.h()},h(){u(i,"href","https://huggingface.co/blog/dreambooth"),u(i,"rel","nofollow")},m(j,I){h(j,f,I),a(f,_),a(f,i),a(i,d),a(f,k)},d(j){j&&t(f)}}}function Gp(A){let f,_,i,d,k,j,I,C,z,N,R,T,U,q,O,G,y,x,L;return N=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export OUTPUT_DIR="path_to_saved_model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>`}}),x=new P({props:{code:`accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400`,highlighted:`accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --max_train_steps=400`}}),{c(){f=o("p"),_=l("Let\u2019s try DreamBooth with a "),i=o("a"),d=l("few images of a dog"),k=l("; download and save them to a directory and then set the "),j=o("code"),I=l("INSTANCE_DIR"),C=l(" environment variable to that path:"),z=c(),g(N.$$.fragment),R=c(),T=o("p"),U=l("Then you can launch the training script (you can find the full training script "),q=o("a"),O=l("here"),G=l(") with the following command:"),y=c(),g(x.$$.fragment),this.h()},l(D){f=r(D,"P",{});var S=n(f);_=p(S,"Let\u2019s try DreamBooth with a "),i=r(S,"A",{href:!0,rel:!0});var Z=n(i);d=p(Z,"few images of a dog"),Z.forEach(t),k=p(S,"; download and save them to a directory and then set the "),j=r(S,"CODE",{});var Bt=n(j);I=p(Bt,"INSTANCE_DIR"),Bt.forEach(t),C=p(S," environment variable to that path:"),S.forEach(t),z=m(D),$(N.$$.fragment,D),R=m(D),T=r(D,"P",{});var W=n(T);U=p(W,"Then you can launch the training script (you can find the full training script "),q=r(W,"A",{href:!0,rel:!0});var Ft=n(q);O=p(Ft,"here"),Ft.forEach(t),G=p(W,") with the following command:"),W.forEach(t),y=m(D),$(x.$$.fragment,D),this.h()},h(){u(i,"href","https://drive.google.com/drive/folders/1BO_dyz-p65qhBRRMRA4TbZ8qW4rB99JZ"),u(i,"rel","nofollow"),u(q,"href","https://github.com/huggingface/diffusers/blob/main/examples/dreambooth/train_dreambooth.py"),u(q,"rel","nofollow")},m(D,S){h(D,f,S),a(f,_),a(f,i),a(i,d),a(f,k),a(f,j),a(j,I),a(f,C),h(D,z,S),v(N,D,S),h(D,R,S),h(D,T,S),a(T,U),a(T,q),a(q,O),a(T,G),h(D,y,S),v(x,D,S),L=!0},p:ha,i(D){L||(b(N.$$.fragment,D),b(x.$$.fragment,D),L=!0)},o(D){w(N.$$.fragment,D),w(x.$$.fragment,D),L=!1},d(D){D&&t(f),D&&t(z),E(N,D),D&&t(R),D&&t(T),D&&t(y),E(x,D)}}}function Bp(A){let f,_;return f=new fa({props:{$$slots:{default:[Gp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Fp(A){let f,_,i,d,k,j,I,C,z,N,R,T,U,q,O,G;return N=new P({props:{code:"pip install -U -r requirements.txt",highlighted:"pip install -U -r requirements.txt"}}),O=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="path-to-instance-images"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --instance_prompt="a photo of sks dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --max_train_steps=400`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path-to-instance-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --max_train_steps=400`}}),{c(){f=o("p"),_=l("If you have access to TPUs or want to train even faster, you can try out the "),i=o("a"),d=l("Flax training script"),k=l(". The Flax training script doesn\u2019t support gradient checkpointing or gradient accumulation, so you\u2019ll need a GPU with at least 30GB of memory."),j=c(),I=o("p"),C=l("Before running the script, make sure you have the requirements installed:"),z=c(),g(N.$$.fragment),R=c(),T=o("p"),U=l("Now you can launch the training script with the following command:"),q=c(),g(O.$$.fragment),this.h()},l(y){f=r(y,"P",{});var x=n(f);_=p(x,"If you have access to TPUs or want to train even faster, you can try out the "),i=r(x,"A",{href:!0,rel:!0});var L=n(i);d=p(L,"Flax training script"),L.forEach(t),k=p(x,". The Flax training script doesn\u2019t support gradient checkpointing or gradient accumulation, so you\u2019ll need a GPU with at least 30GB of memory."),x.forEach(t),j=m(y),I=r(y,"P",{});var D=n(I);C=p(D,"Before running the script, make sure you have the requirements installed:"),D.forEach(t),z=m(y),$(N.$$.fragment,y),R=m(y),T=r(y,"P",{});var S=n(T);U=p(S,"Now you can launch the training script with the following command:"),S.forEach(t),q=m(y),$(O.$$.fragment,y),this.h()},h(){u(i,"href","https://github.com/huggingface/diffusers/blob/main/examples/dreambooth/train_dreambooth_flax.py"),u(i,"rel","nofollow")},m(y,x){h(y,f,x),a(f,_),a(f,i),a(i,d),a(f,k),h(y,j,x),h(y,I,x),a(I,C),h(y,z,x),v(N,y,x),h(y,R,x),h(y,T,x),a(T,U),h(y,q,x),v(O,y,x),G=!0},p:ha,i(y){G||(b(N.$$.fragment,y),b(O.$$.fragment,y),G=!0)},o(y){w(N.$$.fragment,y),w(O.$$.fragment,y),G=!1},d(y){y&&t(f),y&&t(j),y&&t(I),y&&t(z),E(N,y),y&&t(R),y&&t(T),y&&t(q),E(O,y)}}}function Vp(A){let f,_;return f=new fa({props:{$$slots:{default:[Fp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Hp(A){let f,_;return f=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p:ha,i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Yp(A){let f,_;return f=new fa({props:{$$slots:{default:[Hp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Wp(A){let f,_;return f=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="path-to-instance-images"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path-to-instance-images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=5e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p:ha,i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Jp(A){let f,_;return f=new fa({props:{$$slots:{default:[Wp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Zp(A){let f,_;return{c(){f=o("p"),_=l("Training the text encoder requires additional memory and it won\u2019t fit on a 16GB GPU. You\u2019ll need at least 24GB VRAM to use this option.")},l(i){f=r(i,"P",{});var d=n(f);_=p(d,"Training the text encoder requires additional memory and it won\u2019t fit on a 16GB GPU. You\u2019ll need at least 24GB VRAM to use this option."),d.forEach(t)},m(i,d){h(i,f,d),a(f,_)},d(i){i&&t(f)}}}function Kp(A){let f,_;return f=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --train_text_encoder \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --train_text_encoder \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --use_8bit_adam
  --gradient_checkpointing \\
  --learning_rate=2e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p:ha,i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Qp(A){let f,_;return f=new fa({props:{$$slots:{default:[Kp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function Xp(A){let f,_;return f=new P({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export INSTANCE_DIR="path-to-instance-images"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --train_text_encoder \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=2e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path-to-instance-images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

python train_dreambooth_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --train_text_encoder \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --learning_rate=2e-6 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p:ha,i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function eh(A){let f,_;return f=new fa({props:{$$slots:{default:[Xp]},$$scope:{ctx:A}}}),{c(){g(f.$$.fragment)},l(i){$(f.$$.fragment,i)},m(i,d){v(f,i,d),_=!0},p(i,d){const k={};d&2&&(k.$$scope={dirty:d,ctx:i}),f.$set(k)},i(i){_||(b(f.$$.fragment,i),_=!0)},o(i){w(f.$$.fragment,i),_=!1},d(i){E(f,i)}}}function th(A){let f,_,i,d,k,j,I,C,z,N,R,T,U,q,O,G,y,x,L,D,S,Z,Bt,W,Ft,ds,K,lr,Xe,ua,pr,hr,et,fr,ur,gs,me,cr,ca,mr,_r,$s,tt,vs,_e,dr,Vt,gr,$r,bs,de,vr,at,br,wr,ws,st,Es,Ht,Er,ys,ot,ks,Yt,yr,Ds,rt,xs,ee,ge,ma,nt,kr,_a,Dr,As,$e,js,ve,Ps,te,be,da,it,xr,ga,Ar,Ss,we,jr,lt,Pr,Sr,Is,Ee,Ir,$a,Nr,Tr,Ns,ye,Ts,ae,ke,va,pt,qr,ba,Rr,qs,B,Cr,wa,Ur,Or,Ea,Mr,Lr,ht,zr,Gr,Rs,De,Cs,F,Br,ya,Fr,Vr,ka,Hr,Yr,Da,Wr,Jr,Us,xe,Os,se,Ae,xa,ft,Zr,Aa,Kr,Ms,je,Qr,Wt,Xr,en,Ls,oe,Pe,ja,ut,tn,Pa,an,zs,Jt,sn,Gs,ct,Bs,V,on,Sa,rn,nn,Ia,ln,pn,Na,hn,fn,Fs,re,Se,Ta,mt,un,qa,cn,Vs,Q,mn,Ra,_n,dn,Ca,gn,$n,Hs,_t,Ys,Zt,vn,Ws,ne,Ie,Ua,dt,bn,Oa,wn,Js,Kt,En,Zs,Ne,yn,Ma,La,kn,Dn,Ks,gt,Qs,Te,xn,za,Ga,An,jn,Xs,$t,eo,ie,qe,Ba,vt,Pn,Fa,Sn,to,Qt,In,ao,le,Re,Va,bt,Nn,Ha,Tn,so,J,wt,qn,Rn,Et,Cn,Un,Xt,On,Mn,oo,yt,ro,ea,Ln,no,pe,Ce,Ya,kt,zn,Wa,Gn,io,H,Bn,Dt,Fn,Vn,Ja,Hn,Yn,Za,Wn,Jn,lo,xt,po,he,Ue,Ka,At,Zn,Qa,Kn,ho,Oe,Qn,jt,Xn,ei,fo,Pt,uo,Me,ti,Xa,ai,si,co,St,mo,fe,Le,es,It,oi,ts,ri,_o,ze,ni,as,ii,li,go,Nt,$o,ue,Ge,ss,Tt,pi,os,hi,vo,Be,fi,qt,ui,ci,bo,ta,mi,wo,Rt,Eo,Fe,_i,Ct,di,gi,yo,X,$i,Ut,rs,vi,bi,ns,wi,Ei,ko,aa,yi,Do,sa,ki,xo,Ot,Ao,ce,Ve,is,Mt,Di,ls,xi,jo,Y,Ai,oa,ji,Pi,ps,Si,Ii,hs,Ni,Ti,Po,He,qi,fs,us,Ri,Ci,So,Lt,Io,Ye,Ui,ra,Oi,Mi,No;return j=new M({}),R=new Lp({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/dreambooth.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/dreambooth.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/dreambooth.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/dreambooth.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/pytorch/dreambooth.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/diffusers_doc/en/tensorflow/dreambooth.ipynb"}]}}),tt=new P({props:{code:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers
pip install -U -r diffusers/examples/dreambooth/requirements.txt`}}),st=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),ot=new P({props:{code:"accelerate config default",highlighted:"accelerate config default"}}),rt=new P({props:{code:`from accelerate.utils import write_basic_config

write_basic_config()`,highlighted:`<span class="hljs-keyword">from</span> accelerate.utils <span class="hljs-keyword">import</span> write_basic_config

write_basic_config()`}}),nt=new M({}),$e=new Tp({props:{warning:!0,$$slots:{default:[zp]},$$scope:{ctx:A}}}),ve=new zi({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Vp],pytorch:[Bp]},$$scope:{ctx:A}}}),it=new M({}),ye=new zi({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Jp],pytorch:[Yp]},$$scope:{ctx:A}}}),pt=new M({}),De=new Tp({props:{warning:!0,$$slots:{default:[Zp]},$$scope:{ctx:A}}}),xe=new zi({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[eh],pytorch:[Qp]},$$scope:{ctx:A}}}),ft=new M({}),ut=new M({}),ct=new P({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),mt=new M({}),_t=new P({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),dt=new M({}),gt=new P({props:{code:`from diffusers import DiffusionPipeline, UNet2DConditionModel
from transformers import CLIPTextModel
import torch

# Load the pipeline with the same arguments (model, revision) that were used for training
model_id = "CompVis/stable-diffusion-v1-4"

unet = UNet2DConditionModel.from_pretrained("/sddata/dreambooth/daruma-v2-1/checkpoint-100/unet")

# if you have trained with \`--args.train_text_encoder\` make sure to also load the text encoder
text_encoder = CLIPTextModel.from_pretrained("/sddata/dreambooth/daruma-v2-1/checkpoint-100/text_encoder")

pipeline = DiffusionPipeline.from_pretrained(model_id, unet=unet, text_encoder=text_encoder, dtype=torch.float16)
pipeline.to("cuda")

# Perform inference, or save, or push to the hub
pipeline.save_pretrained("dreambooth-pipeline")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, UNet2DConditionModel
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> CLIPTextModel
<span class="hljs-keyword">import</span> torch

<span class="hljs-comment"># Load the pipeline with the same arguments (model, revision) that were used for training</span>
model_id = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>

unet = UNet2DConditionModel.from_pretrained(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100/unet&quot;</span>)

<span class="hljs-comment"># if you have trained with \`--args.train_text_encoder\` make sure to also load the text encoder</span>
text_encoder = CLIPTextModel.from_pretrained(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100/text_encoder&quot;</span>)

pipeline = DiffusionPipeline.from_pretrained(model_id, unet=unet, text_encoder=text_encoder, dtype=torch.float16)
pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># Perform inference, or save, or push to the hub</span>
pipeline.save_pretrained(<span class="hljs-string">&quot;dreambooth-pipeline&quot;</span>)`}}),$t=new P({props:{code:`from accelerate import Accelerator
from diffusers import DiffusionPipeline

# Load the pipeline with the same arguments (model, revision) that were used for training
model_id = "CompVis/stable-diffusion-v1-4"
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

# Use text_encoder if \`--train_text_encoder\` was used for the initial training
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

# Restore state from a checkpoint path. You have to use the absolute path here.
accelerator.load_state("/sddata/dreambooth/daruma-v2-1/checkpoint-100")

# Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

# Perform inference, or save, or push to the hub
pipeline.save_pretrained("dreambooth-pipeline")`,highlighted:`<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-comment"># Load the pipeline with the same arguments (model, revision) that were used for training</span>
model_id = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = DiffusionPipeline.from_pretrained(model_id)

accelerator = Accelerator()

<span class="hljs-comment"># Use text_encoder if \`--train_text_encoder\` was used for the initial training</span>
unet, text_encoder = accelerator.prepare(pipeline.unet, pipeline.text_encoder)

<span class="hljs-comment"># Restore state from a checkpoint path. You have to use the absolute path here.</span>
accelerator.load_state(<span class="hljs-string">&quot;/sddata/dreambooth/daruma-v2-1/checkpoint-100&quot;</span>)

<span class="hljs-comment"># Rebuild the pipeline with the unwrapped models (assignment to .unet and .text_encoder should work too)</span>
pipeline = DiffusionPipeline.from_pretrained(
    model_id,
    unet=accelerator.unwrap_model(unet),
    text_encoder=accelerator.unwrap_model(text_encoder),
)

<span class="hljs-comment"># Perform inference, or save, or push to the hub</span>
pipeline.save_pretrained(<span class="hljs-string">&quot;dreambooth-pipeline&quot;</span>)`}}),vt=new M({}),bt=new M({}),yt=new P({props:{code:"  --enable_xformers_memory_efficient_attention",highlighted:"  --enable_xformers_memory_efficient_attention"}}),kt=new M({}),xt=new P({props:{code:"  --set_grads_to_none",highlighted:"  --set_grads_to_none"}}),At=new M({}),Pt=new P({props:{code:"pip install bitsandbytes",highlighted:"pip install bitsandbytes"}}),St=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=2 --gradient_checkpointing \\
  --use_8bit_adam \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),It=new M({}),Nt=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path-to-instance-images"
export CLASS_DIR="path-to-class-images"
export OUTPUT_DIR="path-to-save-model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME  \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --use_8bit_adam \\
  --enable_xformers_memory_efficient_attention \\
  --set_grads_to_none \\
  --learning_rate=2e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path-to-instance-images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path-to-class-images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path-to-save-model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span>  \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --use_8bit_adam \\
  --enable_xformers_memory_efficient_attention \\
  --set_grads_to_none \\
  --learning_rate=2e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800`}}),Tt=new M({}),Rt=new P({props:{code:"accelerate config",highlighted:"accelerate config"}}),Ot=new P({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export INSTANCE_DIR="path_to_training_images"
export CLASS_DIR="path_to_class_images"
export OUTPUT_DIR="path_to_saved_model"

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --instance_data_dir=$INSTANCE_DIR \\
  --class_data_dir=$CLASS_DIR \\
  --output_dir=$OUTPUT_DIR \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt="a photo of sks dog" \\
  --class_prompt="a photo of dog" \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler="constant" \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> INSTANCE_DIR=<span class="hljs-string">&quot;path_to_training_images&quot;</span>
<span class="hljs-built_in">export</span> CLASS_DIR=<span class="hljs-string">&quot;path_to_class_images&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_saved_model&quot;</span>

accelerate launch train_dreambooth.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --instance_data_dir=<span class="hljs-variable">$INSTANCE_DIR</span> \\
  --class_data_dir=<span class="hljs-variable">$CLASS_DIR</span> \\
  --output_dir=<span class="hljs-variable">$OUTPUT_DIR</span> \\
  --with_prior_preservation --prior_loss_weight=1.0 \\
  --instance_prompt=<span class="hljs-string">&quot;a photo of sks dog&quot;</span> \\
  --class_prompt=<span class="hljs-string">&quot;a photo of dog&quot;</span> \\
  --resolution=512 \\
  --train_batch_size=1 \\
  --sample_batch_size=1 \\
  --gradient_accumulation_steps=1 --gradient_checkpointing \\
  --learning_rate=5e-6 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> \\
  --lr_warmup_steps=0 \\
  --num_class_images=200 \\
  --max_train_steps=800 \\
  --mixed_precision=fp16`}}),Mt=new M({}),Lt=new P({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

prompt = "A photo of sks dog in a bucket"
image = pipe(prompt, num_inference_steps=50, guidance_scale=7.5).images[0]

image.save("dog-bucket.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;A photo of sks dog in a bucket&quot;</span>
image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>, guidance_scale=<span class="hljs-number">7.5</span>).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;dog-bucket.png&quot;</span>)`}}),{c(){f=o("meta"),_=c(),i=o("h1"),d=o("a"),k=o("span"),g(j.$$.fragment),I=c(),C=o("span"),z=l("DreamBooth"),N=c(),g(R.$$.fragment),T=c(),U=o("p"),q=o("a"),O=l("DreamBooth"),G=l(" is a method to personalize text-to-image models like Stable Diffusion given just a few (3-5) images of a subject. It allows the model to generate contextualized images of the subject in different scenes, poses, and views."),y=c(),x=o("p"),L=o("img"),S=c(),Z=o("small"),Bt=l("Dreambooth examples from the "),W=o("a"),Ft=l("project's blog."),ds=c(),K=o("p"),lr=l("This guide will show you how to finetune DreamBooth with the "),Xe=o("a"),ua=o("code"),pr=l("CompVis/stable-diffusion-v1-4"),hr=l(" model for various GPU sizes, and with Flax. All the training scripts for DreamBooth used in this guide can be found "),et=o("a"),fr=l("here"),ur=l(" if you\u2019re interested in digging deeper and seeing how things work."),gs=c(),me=o("p"),cr=l("Before running the scripts, make sure you install the library\u2019s training dependencies. We also recommend installing \u{1F9E8} Diffusers from the "),ca=o("code"),mr=l("main"),_r=l(" GitHub branch:"),$s=c(),g(tt.$$.fragment),vs=c(),_e=o("p"),dr=l("xFormers is not part of the training requirements, but we recommend you "),Vt=o("a"),gr=l("install"),$r=l(" it if you can because it could make your training faster and less memory intensive."),bs=c(),de=o("p"),vr=l("After all the dependencies have been set up, initialize a "),at=o("a"),br=l("\u{1F917} Accelerate"),wr=l(" environment with:"),ws=c(),g(st.$$.fragment),Es=c(),Ht=o("p"),Er=l("To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),ys=c(),g(ot.$$.fragment),ks=c(),Yt=o("p"),yr=l("Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),Ds=c(),g(rt.$$.fragment),xs=c(),ee=o("h2"),ge=o("a"),ma=o("span"),g(nt.$$.fragment),kr=c(),_a=o("span"),Dr=l("Finetuning"),As=c(),g($e.$$.fragment),js=c(),g(ve.$$.fragment),Ps=c(),te=o("h2"),be=o("a"),da=o("span"),g(it.$$.fragment),xr=c(),ga=o("span"),Ar=l("Finetuning with prior-preserving loss"),Ss=c(),we=o("p"),jr=l("Prior preservation is used to avoid overfitting and language-drift (check out the "),lt=o("a"),Pr=l("paper"),Sr=l(" to learn more if you\u2019re interested). For prior preservation, you use other images of the same class as part of the training process. The nice thing is that you can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path you specify."),Is=c(),Ee=o("p"),Ir=l("The authors recommend generating "),$a=o("code"),Nr=l("num_epochs * num_samples"),Tr=l(" images for prior preservation. In most cases, 200-300 images work well."),Ns=c(),g(ye.$$.fragment),Ts=c(),ae=o("h2"),ke=o("a"),va=o("span"),g(pt.$$.fragment),qr=c(),ba=o("span"),Rr=l("Finetuning the text encoder and UNet"),qs=c(),B=o("p"),Cr=l("The script also allows you to finetune the "),wa=o("code"),Ur=l("text_encoder"),Or=l(" along with the "),Ea=o("code"),Mr=l("unet"),Lr=l(". In our experiments (check out the "),ht=o("a"),zr=l("Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),Gr=l(" post for more details), this yields much better results, especially when generating images of faces."),Rs=c(),g(De.$$.fragment),Cs=c(),F=o("p"),Br=l("Pass the "),ya=o("code"),Fr=l("--train_text_encoder"),Vr=l(" argument to the training script to enable finetuning the "),ka=o("code"),Hr=l("text_encoder"),Yr=l(" and "),Da=o("code"),Wr=l("unet"),Jr=l(":"),Us=c(),g(xe.$$.fragment),Os=c(),se=o("h2"),Ae=o("a"),xa=o("span"),g(ft.$$.fragment),Zr=c(),Aa=o("span"),Kr=l("Finetuning with LoRA"),Ms=c(),je=o("p"),Qr=l("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, on DreamBooth. For more details, take a look at the "),Wt=o("a"),Xr=l("LoRA training"),en=l(" guide."),Ls=c(),oe=o("h2"),Pe=o("a"),ja=o("span"),g(ut.$$.fragment),tn=c(),Pa=o("span"),an=l("Saving checkpoints while training"),zs=c(),Jt=o("p"),sn=l("It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the training process. One of the intermediate checkpoints might actually work better than the final model! Pass the following argument to the training script to enable saving checkpoints:"),Gs=c(),g(ct.$$.fragment),Bs=c(),V=o("p"),on=l("This saves the full training state in subfolders of your "),Sa=o("code"),rn=l("output_dir"),nn=l(". Subfolder names begin with the prefix "),Ia=o("code"),ln=l("checkpoint-"),pn=l(", followed by the number of steps performed so far; for example, "),Na=o("code"),hn=l("checkpoint-1500"),fn=l(" would be a checkpoint saved after 1500 training steps."),Fs=c(),re=o("h3"),Se=o("a"),Ta=o("span"),g(mt.$$.fragment),un=c(),qa=o("span"),cn=l("Resume training from a saved checkpoint"),Vs=c(),Q=o("p"),mn=l("If you want to resume training from any of the saved checkpoints, you can pass the argument "),Ra=o("code"),_n=l("--resume_from_checkpoint"),dn=l(" to the script and specify the name of the checkpoint you want to use. You can also use the special string "),Ca=o("code"),gn=l('"latest"'),$n=l(" to resume from the last saved checkpoint (the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),Hs=c(),g(_t.$$.fragment),Ys=c(),Zt=o("p"),vn=l("This is a good opportunity to tweak some of your hyperparameters if you wish."),Ws=c(),ne=o("h3"),Ie=o("a"),Ua=o("span"),g(dt.$$.fragment),bn=c(),Oa=o("span"),wn=l("Inference from a saved checkpoint"),Js=c(),Kt=o("p"),En=l("Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders, and learning rate."),Zs=c(),Ne=o("p"),yn=l("If you have "),Ma=o("strong"),La=o("code"),kn=l('"accelerate>=0.16.0"'),Dn=l(` installed, use the following code to run
inference from an intermediate checkpoint.`),Ks=c(),g(gt.$$.fragment),Qs=c(),Te=o("p"),xn=l("If you have "),za=o("strong"),Ga=o("code"),An=l('"accelerate<0.16.0"'),jn=l(" installed, you need to convert it to an inference pipeline first:"),Xs=c(),g($t.$$.fragment),eo=c(),ie=o("h2"),qe=o("a"),Ba=o("span"),g(vt.$$.fragment),Pn=c(),Fa=o("span"),Sn=l("Optimizations for different GPU sizes"),to=c(),Qt=o("p"),In=l("Depending on your hardware, there are a few different ways to optimize DreamBooth on GPUs from 16GB to just 8GB!"),ao=c(),le=o("h3"),Re=o("a"),Va=o("span"),g(bt.$$.fragment),Nn=c(),Ha=o("span"),Tn=l("xFormers"),so=c(),J=o("p"),wt=o("a"),qn=l("xFormers"),Rn=l(" is a toolbox for optimizing Transformers, and it includes a "),Et=o("a"),Cn=l("memory-efficient attention"),Un=l(" mechanism that is used in \u{1F9E8} Diffusers. You\u2019ll need to "),Xt=o("a"),On=l("install xFormers"),Mn=l(" and then add the following argument to your training script:"),oo=c(),g(yt.$$.fragment),ro=c(),ea=o("p"),Ln=l("xFormers is not available in Flax."),no=c(),pe=o("h3"),Ce=o("a"),Ya=o("span"),g(kt.$$.fragment),zn=c(),Wa=o("span"),Gn=l("Set gradients to none"),io=c(),H=o("p"),Bn=l("Another way you can lower your memory footprint is to "),Dt=o("a"),Fn=l("set the gradients"),Vn=l(" to "),Ja=o("code"),Hn=l("None"),Yn=l(" instead of zero. However, this may change certain behaviors, so if you run into any issues, try removing this argument. Add the following argument to your training script to set the gradients to "),Za=o("code"),Wn=l("None"),Jn=l(":"),lo=c(),g(xt.$$.fragment),po=c(),he=o("h3"),Ue=o("a"),Ka=o("span"),g(At.$$.fragment),Zn=c(),Qa=o("span"),Kn=l("16GB GPU"),ho=c(),Oe=o("p"),Qn=l("With the help of gradient checkpointing and "),jt=o("a"),Xn=l("bitsandbytes"),ei=l(" 8-bit optimizer, it\u2019s possible to train DreamBooth on a 16GB GPU. Make sure you have bitsandbytes installed:"),fo=c(),g(Pt.$$.fragment),uo=c(),Me=o("p"),ti=l("Then pass the "),Xa=o("code"),ai=l("--use_8bit_adam"),si=l(" option to the training script:"),co=c(),g(St.$$.fragment),mo=c(),fe=o("h3"),Le=o("a"),es=o("span"),g(It.$$.fragment),oi=c(),ts=o("span"),ri=l("12GB GPU"),_o=c(),ze=o("p"),ni=l("To run DreamBooth on a 12GB GPU, you\u2019ll need to enable gradient checkpointing, the 8-bit optimizer, xFormers, and set the gradients to "),as=o("code"),ii=l("None"),li=l(":"),go=c(),g(Nt.$$.fragment),$o=c(),ue=o("h3"),Ge=o("a"),ss=o("span"),g(Tt.$$.fragment),pi=c(),os=o("span"),hi=l("8 GB GPU"),vo=c(),Be=o("p"),fi=l("For 8GB GPUs, you\u2019ll need the help of "),qt=o("a"),ui=l("DeepSpeed"),ci=l(` to offload some
tensors from the VRAM to either the CPU or NVME, enabling training with less GPU memory.`),bo=c(),ta=o("p"),mi=l("Run the following command to configure your \u{1F917} Accelerate environment:"),wo=c(),g(Rt.$$.fragment),Eo=c(),Fe=o("p"),_i=l("During configuration, confirm that you want to use DeepSpeed. Now it\u2019s possible to train on under 8GB VRAM by combining DeepSpeed stage 2, fp16 mixed precision, and offloading the model parameters and the optimizer state to the CPU. The drawback is that this requires more system RAM, about 25 GB. See "),Ct=o("a"),di=l("the DeepSpeed documentation"),gi=l(" for more configuration options."),yo=c(),X=o("p"),$i=l(`You should also change the default Adam optimizer to DeepSpeed\u2019s optimized version of Adam
`),Ut=o("a"),rs=o("code"),vi=l("deepspeed.ops.adam.DeepSpeedCPUAdam"),bi=l(" for a substantial speedup. Enabling "),ns=o("code"),wi=l("DeepSpeedCPUAdam"),Ei=l(" requires your system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch."),ko=c(),aa=o("p"),yi=l("8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment."),Do=c(),sa=o("p"),ki=l("Launch training with the following command:"),xo=c(),g(Ot.$$.fragment),Ao=c(),ce=o("h2"),Ve=o("a"),is=o("span"),g(Mt.$$.fragment),Di=c(),ls=o("span"),xi=l("Inference"),jo=c(),Y=o("p"),Ai=l("Once you have trained a model, specify the path to where the model is saved, and use it for inference in the "),oa=o("a"),ji=l("StableDiffusionPipeline"),Pi=l(". Make sure your prompts include the special "),ps=o("code"),Si=l("identifier"),Ii=l(" used during training ("),hs=o("code"),Ni=l("sks"),Ti=l(" in the previous examples)."),Po=c(),He=o("p"),qi=l("If you have "),fs=o("strong"),us=o("code"),Ri=l('"accelerate>=0.16.0"'),Ci=l(` installed, you can use the following code to run
inference from an intermediate checkpoint:`),So=c(),g(Lt.$$.fragment),Io=c(),Ye=o("p"),Ui=l("You may also run inference from any of the "),ra=o("a"),Oi=l("saved training checkpoints"),Mi=l("."),this.h()},l(e){const s=Up('[data-svelte="svelte-1phssyn"]',document.head);f=r(s,"META",{name:!0,content:!0}),s.forEach(t),_=m(e),i=r(e,"H1",{class:!0});var zt=n(i);d=r(zt,"A",{id:!0,class:!0,href:!0});var cs=n(d);k=r(cs,"SPAN",{});var ms=n(k);$(j.$$.fragment,ms),ms.forEach(t),cs.forEach(t),I=m(zt),C=r(zt,"SPAN",{});var _s=n(C);z=p(_s,"DreamBooth"),_s.forEach(t),zt.forEach(t),N=m(e),$(R.$$.fragment,e),T=m(e),U=r(e,"P",{});var na=n(U);q=r(na,"A",{href:!0,rel:!0});var Gi=n(q);O=p(Gi,"DreamBooth"),Gi.forEach(t),G=p(na," is a method to personalize text-to-image models like Stable Diffusion given just a few (3-5) images of a subject. It allows the model to generate contextualized images of the subject in different scenes, poses, and views."),na.forEach(t),y=m(e),x=r(e,"P",{});var Bi=n(x);L=r(Bi,"IMG",{src:!0,alt:!0}),Bi.forEach(t),S=m(e),Z=r(e,"SMALL",{});var Li=n(Z);Bt=p(Li,"Dreambooth examples from the "),W=r(Li,"A",{href:!0});var Fi=n(W);Ft=p(Fi,"project's blog."),Fi.forEach(t),Li.forEach(t),ds=m(e),K=r(e,"P",{});var ia=n(K);lr=p(ia,"This guide will show you how to finetune DreamBooth with the "),Xe=r(ia,"A",{href:!0,rel:!0});var Vi=n(Xe);ua=r(Vi,"CODE",{});var Hi=n(ua);pr=p(Hi,"CompVis/stable-diffusion-v1-4"),Hi.forEach(t),Vi.forEach(t),hr=p(ia," model for various GPU sizes, and with Flax. All the training scripts for DreamBooth used in this guide can be found "),et=r(ia,"A",{href:!0,rel:!0});var Yi=n(et);fr=p(Yi,"here"),Yi.forEach(t),ur=p(ia," if you\u2019re interested in digging deeper and seeing how things work."),ia.forEach(t),gs=m(e),me=r(e,"P",{});var To=n(me);cr=p(To,"Before running the scripts, make sure you install the library\u2019s training dependencies. We also recommend installing \u{1F9E8} Diffusers from the "),ca=r(To,"CODE",{});var Wi=n(ca);mr=p(Wi,"main"),Wi.forEach(t),_r=p(To," GitHub branch:"),To.forEach(t),$s=m(e),$(tt.$$.fragment,e),vs=m(e),_e=r(e,"P",{});var qo=n(_e);dr=p(qo,"xFormers is not part of the training requirements, but we recommend you "),Vt=r(qo,"A",{href:!0});var Ji=n(Vt);gr=p(Ji,"install"),Ji.forEach(t),$r=p(qo," it if you can because it could make your training faster and less memory intensive."),qo.forEach(t),bs=m(e),de=r(e,"P",{});var Ro=n(de);vr=p(Ro,"After all the dependencies have been set up, initialize a "),at=r(Ro,"A",{href:!0,rel:!0});var Zi=n(at);br=p(Zi,"\u{1F917} Accelerate"),Zi.forEach(t),wr=p(Ro," environment with:"),Ro.forEach(t),ws=m(e),$(st.$$.fragment,e),Es=m(e),Ht=r(e,"P",{});var Ki=n(Ht);Er=p(Ki,"To setup a default \u{1F917} Accelerate environment without choosing any configurations:"),Ki.forEach(t),ys=m(e),$(ot.$$.fragment,e),ks=m(e),Yt=r(e,"P",{});var Qi=n(Yt);yr=p(Qi,"Or if your environment doesn\u2019t support an interactive shell like a notebook, you can use:"),Qi.forEach(t),Ds=m(e),$(rt.$$.fragment,e),xs=m(e),ee=r(e,"H2",{class:!0});var Co=n(ee);ge=r(Co,"A",{id:!0,class:!0,href:!0});var Xi=n(ge);ma=r(Xi,"SPAN",{});var el=n(ma);$(nt.$$.fragment,el),el.forEach(t),Xi.forEach(t),kr=m(Co),_a=r(Co,"SPAN",{});var tl=n(_a);Dr=p(tl,"Finetuning"),tl.forEach(t),Co.forEach(t),As=m(e),$($e.$$.fragment,e),js=m(e),$(ve.$$.fragment,e),Ps=m(e),te=r(e,"H2",{class:!0});var Uo=n(te);be=r(Uo,"A",{id:!0,class:!0,href:!0});var al=n(be);da=r(al,"SPAN",{});var sl=n(da);$(it.$$.fragment,sl),sl.forEach(t),al.forEach(t),xr=m(Uo),ga=r(Uo,"SPAN",{});var ol=n(ga);Ar=p(ol,"Finetuning with prior-preserving loss"),ol.forEach(t),Uo.forEach(t),Ss=m(e),we=r(e,"P",{});var Oo=n(we);jr=p(Oo,"Prior preservation is used to avoid overfitting and language-drift (check out the "),lt=r(Oo,"A",{href:!0,rel:!0});var rl=n(lt);Pr=p(rl,"paper"),rl.forEach(t),Sr=p(Oo," to learn more if you\u2019re interested). For prior preservation, you use other images of the same class as part of the training process. The nice thing is that you can generate those images using the Stable Diffusion model itself! The training script will save the generated images to a local path you specify."),Oo.forEach(t),Is=m(e),Ee=r(e,"P",{});var Mo=n(Ee);Ir=p(Mo,"The authors recommend generating "),$a=r(Mo,"CODE",{});var nl=n($a);Nr=p(nl,"num_epochs * num_samples"),nl.forEach(t),Tr=p(Mo," images for prior preservation. In most cases, 200-300 images work well."),Mo.forEach(t),Ns=m(e),$(ye.$$.fragment,e),Ts=m(e),ae=r(e,"H2",{class:!0});var Lo=n(ae);ke=r(Lo,"A",{id:!0,class:!0,href:!0});var il=n(ke);va=r(il,"SPAN",{});var ll=n(va);$(pt.$$.fragment,ll),ll.forEach(t),il.forEach(t),qr=m(Lo),ba=r(Lo,"SPAN",{});var pl=n(ba);Rr=p(pl,"Finetuning the text encoder and UNet"),pl.forEach(t),Lo.forEach(t),qs=m(e),B=r(e,"P",{});var We=n(B);Cr=p(We,"The script also allows you to finetune the "),wa=r(We,"CODE",{});var hl=n(wa);Ur=p(hl,"text_encoder"),hl.forEach(t),Or=p(We," along with the "),Ea=r(We,"CODE",{});var fl=n(Ea);Mr=p(fl,"unet"),fl.forEach(t),Lr=p(We,". In our experiments (check out the "),ht=r(We,"A",{href:!0,rel:!0});var ul=n(ht);zr=p(ul,"Training Stable Diffusion with DreamBooth using \u{1F9E8} Diffusers"),ul.forEach(t),Gr=p(We," post for more details), this yields much better results, especially when generating images of faces."),We.forEach(t),Rs=m(e),$(De.$$.fragment,e),Cs=m(e),F=r(e,"P",{});var Je=n(F);Br=p(Je,"Pass the "),ya=r(Je,"CODE",{});var cl=n(ya);Fr=p(cl,"--train_text_encoder"),cl.forEach(t),Vr=p(Je," argument to the training script to enable finetuning the "),ka=r(Je,"CODE",{});var ml=n(ka);Hr=p(ml,"text_encoder"),ml.forEach(t),Yr=p(Je," and "),Da=r(Je,"CODE",{});var _l=n(Da);Wr=p(_l,"unet"),_l.forEach(t),Jr=p(Je,":"),Je.forEach(t),Us=m(e),$(xe.$$.fragment,e),Os=m(e),se=r(e,"H2",{class:!0});var zo=n(se);Ae=r(zo,"A",{id:!0,class:!0,href:!0});var dl=n(Ae);xa=r(dl,"SPAN",{});var gl=n(xa);$(ft.$$.fragment,gl),gl.forEach(t),dl.forEach(t),Zr=m(zo),Aa=r(zo,"SPAN",{});var $l=n(Aa);Kr=p($l,"Finetuning with LoRA"),$l.forEach(t),zo.forEach(t),Ms=m(e),je=r(e,"P",{});var Go=n(je);Qr=p(Go,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, on DreamBooth. For more details, take a look at the "),Wt=r(Go,"A",{href:!0});var vl=n(Wt);Xr=p(vl,"LoRA training"),vl.forEach(t),en=p(Go," guide."),Go.forEach(t),Ls=m(e),oe=r(e,"H2",{class:!0});var Bo=n(oe);Pe=r(Bo,"A",{id:!0,class:!0,href:!0});var bl=n(Pe);ja=r(bl,"SPAN",{});var wl=n(ja);$(ut.$$.fragment,wl),wl.forEach(t),bl.forEach(t),tn=m(Bo),Pa=r(Bo,"SPAN",{});var El=n(Pa);an=p(El,"Saving checkpoints while training"),El.forEach(t),Bo.forEach(t),zs=m(e),Jt=r(e,"P",{});var yl=n(Jt);sn=p(yl,"It\u2019s easy to overfit while training with Dreambooth, so sometimes it\u2019s useful to save regular checkpoints during the training process. One of the intermediate checkpoints might actually work better than the final model! Pass the following argument to the training script to enable saving checkpoints:"),yl.forEach(t),Gs=m(e),$(ct.$$.fragment,e),Bs=m(e),V=r(e,"P",{});var Ze=n(V);on=p(Ze,"This saves the full training state in subfolders of your "),Sa=r(Ze,"CODE",{});var kl=n(Sa);rn=p(kl,"output_dir"),kl.forEach(t),nn=p(Ze,". Subfolder names begin with the prefix "),Ia=r(Ze,"CODE",{});var Dl=n(Ia);ln=p(Dl,"checkpoint-"),Dl.forEach(t),pn=p(Ze,", followed by the number of steps performed so far; for example, "),Na=r(Ze,"CODE",{});var xl=n(Na);hn=p(xl,"checkpoint-1500"),xl.forEach(t),fn=p(Ze," would be a checkpoint saved after 1500 training steps."),Ze.forEach(t),Fs=m(e),re=r(e,"H3",{class:!0});var Fo=n(re);Se=r(Fo,"A",{id:!0,class:!0,href:!0});var Al=n(Se);Ta=r(Al,"SPAN",{});var jl=n(Ta);$(mt.$$.fragment,jl),jl.forEach(t),Al.forEach(t),un=m(Fo),qa=r(Fo,"SPAN",{});var Pl=n(qa);cn=p(Pl,"Resume training from a saved checkpoint"),Pl.forEach(t),Fo.forEach(t),Vs=m(e),Q=r(e,"P",{});var la=n(Q);mn=p(la,"If you want to resume training from any of the saved checkpoints, you can pass the argument "),Ra=r(la,"CODE",{});var Sl=n(Ra);_n=p(Sl,"--resume_from_checkpoint"),Sl.forEach(t),dn=p(la," to the script and specify the name of the checkpoint you want to use. You can also use the special string "),Ca=r(la,"CODE",{});var Il=n(Ca);gn=p(Il,'"latest"'),Il.forEach(t),$n=p(la," to resume from the last saved checkpoint (the one with the largest number of steps). For example, the following would resume training from the checkpoint saved after 1500 steps:"),la.forEach(t),Hs=m(e),$(_t.$$.fragment,e),Ys=m(e),Zt=r(e,"P",{});var Nl=n(Zt);vn=p(Nl,"This is a good opportunity to tweak some of your hyperparameters if you wish."),Nl.forEach(t),Ws=m(e),ne=r(e,"H3",{class:!0});var Vo=n(ne);Ie=r(Vo,"A",{id:!0,class:!0,href:!0});var Tl=n(Ie);Ua=r(Tl,"SPAN",{});var ql=n(Ua);$(dt.$$.fragment,ql),ql.forEach(t),Tl.forEach(t),bn=m(Vo),Oa=r(Vo,"SPAN",{});var Rl=n(Oa);wn=p(Rl,"Inference from a saved checkpoint"),Rl.forEach(t),Vo.forEach(t),Js=m(e),Kt=r(e,"P",{});var Cl=n(Kt);En=p(Cl,"Saved checkpoints are stored in a format suitable for resuming training. They not only include the model weights, but also the state of the optimizer, data loaders, and learning rate."),Cl.forEach(t),Zs=m(e),Ne=r(e,"P",{});var Ho=n(Ne);yn=p(Ho,"If you have "),Ma=r(Ho,"STRONG",{});var Ul=n(Ma);La=r(Ul,"CODE",{});var Ol=n(La);kn=p(Ol,'"accelerate>=0.16.0"'),Ol.forEach(t),Ul.forEach(t),Dn=p(Ho,` installed, use the following code to run
inference from an intermediate checkpoint.`),Ho.forEach(t),Ks=m(e),$(gt.$$.fragment,e),Qs=m(e),Te=r(e,"P",{});var Yo=n(Te);xn=p(Yo,"If you have "),za=r(Yo,"STRONG",{});var Ml=n(za);Ga=r(Ml,"CODE",{});var Ll=n(Ga);An=p(Ll,'"accelerate<0.16.0"'),Ll.forEach(t),Ml.forEach(t),jn=p(Yo," installed, you need to convert it to an inference pipeline first:"),Yo.forEach(t),Xs=m(e),$($t.$$.fragment,e),eo=m(e),ie=r(e,"H2",{class:!0});var Wo=n(ie);qe=r(Wo,"A",{id:!0,class:!0,href:!0});var zl=n(qe);Ba=r(zl,"SPAN",{});var Gl=n(Ba);$(vt.$$.fragment,Gl),Gl.forEach(t),zl.forEach(t),Pn=m(Wo),Fa=r(Wo,"SPAN",{});var Bl=n(Fa);Sn=p(Bl,"Optimizations for different GPU sizes"),Bl.forEach(t),Wo.forEach(t),to=m(e),Qt=r(e,"P",{});var Fl=n(Qt);In=p(Fl,"Depending on your hardware, there are a few different ways to optimize DreamBooth on GPUs from 16GB to just 8GB!"),Fl.forEach(t),ao=m(e),le=r(e,"H3",{class:!0});var Jo=n(le);Re=r(Jo,"A",{id:!0,class:!0,href:!0});var Vl=n(Re);Va=r(Vl,"SPAN",{});var Hl=n(Va);$(bt.$$.fragment,Hl),Hl.forEach(t),Vl.forEach(t),Nn=m(Jo),Ha=r(Jo,"SPAN",{});var Yl=n(Ha);Tn=p(Yl,"xFormers"),Yl.forEach(t),Jo.forEach(t),so=m(e),J=r(e,"P",{});var Gt=n(J);wt=r(Gt,"A",{href:!0,rel:!0});var Wl=n(wt);qn=p(Wl,"xFormers"),Wl.forEach(t),Rn=p(Gt," is a toolbox for optimizing Transformers, and it includes a "),Et=r(Gt,"A",{href:!0,rel:!0});var Jl=n(Et);Cn=p(Jl,"memory-efficient attention"),Jl.forEach(t),Un=p(Gt," mechanism that is used in \u{1F9E8} Diffusers. You\u2019ll need to "),Xt=r(Gt,"A",{href:!0});var Zl=n(Xt);On=p(Zl,"install xFormers"),Zl.forEach(t),Mn=p(Gt," and then add the following argument to your training script:"),Gt.forEach(t),oo=m(e),$(yt.$$.fragment,e),ro=m(e),ea=r(e,"P",{});var Kl=n(ea);Ln=p(Kl,"xFormers is not available in Flax."),Kl.forEach(t),no=m(e),pe=r(e,"H3",{class:!0});var Zo=n(pe);Ce=r(Zo,"A",{id:!0,class:!0,href:!0});var Ql=n(Ce);Ya=r(Ql,"SPAN",{});var Xl=n(Ya);$(kt.$$.fragment,Xl),Xl.forEach(t),Ql.forEach(t),zn=m(Zo),Wa=r(Zo,"SPAN",{});var ep=n(Wa);Gn=p(ep,"Set gradients to none"),ep.forEach(t),Zo.forEach(t),io=m(e),H=r(e,"P",{});var Ke=n(H);Bn=p(Ke,"Another way you can lower your memory footprint is to "),Dt=r(Ke,"A",{href:!0,rel:!0});var tp=n(Dt);Fn=p(tp,"set the gradients"),tp.forEach(t),Vn=p(Ke," to "),Ja=r(Ke,"CODE",{});var ap=n(Ja);Hn=p(ap,"None"),ap.forEach(t),Yn=p(Ke," instead of zero. However, this may change certain behaviors, so if you run into any issues, try removing this argument. Add the following argument to your training script to set the gradients to "),Za=r(Ke,"CODE",{});var sp=n(Za);Wn=p(sp,"None"),sp.forEach(t),Jn=p(Ke,":"),Ke.forEach(t),lo=m(e),$(xt.$$.fragment,e),po=m(e),he=r(e,"H3",{class:!0});var Ko=n(he);Ue=r(Ko,"A",{id:!0,class:!0,href:!0});var op=n(Ue);Ka=r(op,"SPAN",{});var rp=n(Ka);$(At.$$.fragment,rp),rp.forEach(t),op.forEach(t),Zn=m(Ko),Qa=r(Ko,"SPAN",{});var np=n(Qa);Kn=p(np,"16GB GPU"),np.forEach(t),Ko.forEach(t),ho=m(e),Oe=r(e,"P",{});var Qo=n(Oe);Qn=p(Qo,"With the help of gradient checkpointing and "),jt=r(Qo,"A",{href:!0,rel:!0});var ip=n(jt);Xn=p(ip,"bitsandbytes"),ip.forEach(t),ei=p(Qo," 8-bit optimizer, it\u2019s possible to train DreamBooth on a 16GB GPU. Make sure you have bitsandbytes installed:"),Qo.forEach(t),fo=m(e),$(Pt.$$.fragment,e),uo=m(e),Me=r(e,"P",{});var Xo=n(Me);ti=p(Xo,"Then pass the "),Xa=r(Xo,"CODE",{});var lp=n(Xa);ai=p(lp,"--use_8bit_adam"),lp.forEach(t),si=p(Xo," option to the training script:"),Xo.forEach(t),co=m(e),$(St.$$.fragment,e),mo=m(e),fe=r(e,"H3",{class:!0});var er=n(fe);Le=r(er,"A",{id:!0,class:!0,href:!0});var pp=n(Le);es=r(pp,"SPAN",{});var hp=n(es);$(It.$$.fragment,hp),hp.forEach(t),pp.forEach(t),oi=m(er),ts=r(er,"SPAN",{});var fp=n(ts);ri=p(fp,"12GB GPU"),fp.forEach(t),er.forEach(t),_o=m(e),ze=r(e,"P",{});var tr=n(ze);ni=p(tr,"To run DreamBooth on a 12GB GPU, you\u2019ll need to enable gradient checkpointing, the 8-bit optimizer, xFormers, and set the gradients to "),as=r(tr,"CODE",{});var up=n(as);ii=p(up,"None"),up.forEach(t),li=p(tr,":"),tr.forEach(t),go=m(e),$(Nt.$$.fragment,e),$o=m(e),ue=r(e,"H3",{class:!0});var ar=n(ue);Ge=r(ar,"A",{id:!0,class:!0,href:!0});var cp=n(Ge);ss=r(cp,"SPAN",{});var mp=n(ss);$(Tt.$$.fragment,mp),mp.forEach(t),cp.forEach(t),pi=m(ar),os=r(ar,"SPAN",{});var _p=n(os);hi=p(_p,"8 GB GPU"),_p.forEach(t),ar.forEach(t),vo=m(e),Be=r(e,"P",{});var sr=n(Be);fi=p(sr,"For 8GB GPUs, you\u2019ll need the help of "),qt=r(sr,"A",{href:!0,rel:!0});var dp=n(qt);ui=p(dp,"DeepSpeed"),dp.forEach(t),ci=p(sr,` to offload some
tensors from the VRAM to either the CPU or NVME, enabling training with less GPU memory.`),sr.forEach(t),bo=m(e),ta=r(e,"P",{});var gp=n(ta);mi=p(gp,"Run the following command to configure your \u{1F917} Accelerate environment:"),gp.forEach(t),wo=m(e),$(Rt.$$.fragment,e),Eo=m(e),Fe=r(e,"P",{});var or=n(Fe);_i=p(or,"During configuration, confirm that you want to use DeepSpeed. Now it\u2019s possible to train on under 8GB VRAM by combining DeepSpeed stage 2, fp16 mixed precision, and offloading the model parameters and the optimizer state to the CPU. The drawback is that this requires more system RAM, about 25 GB. See "),Ct=r(or,"A",{href:!0,rel:!0});var $p=n(Ct);di=p($p,"the DeepSpeed documentation"),$p.forEach(t),gi=p(or," for more configuration options."),or.forEach(t),yo=m(e),X=r(e,"P",{});var pa=n(X);$i=p(pa,`You should also change the default Adam optimizer to DeepSpeed\u2019s optimized version of Adam
`),Ut=r(pa,"A",{href:!0,rel:!0});var vp=n(Ut);rs=r(vp,"CODE",{});var bp=n(rs);vi=p(bp,"deepspeed.ops.adam.DeepSpeedCPUAdam"),bp.forEach(t),vp.forEach(t),bi=p(pa," for a substantial speedup. Enabling "),ns=r(pa,"CODE",{});var wp=n(ns);wi=p(wp,"DeepSpeedCPUAdam"),wp.forEach(t),Ei=p(pa," requires your system\u2019s CUDA toolchain version to be the same as the one installed with PyTorch."),pa.forEach(t),ko=m(e),aa=r(e,"P",{});var Ep=n(aa);yi=p(Ep,"8-bit optimizers don\u2019t seem to be compatible with DeepSpeed at the moment."),Ep.forEach(t),Do=m(e),sa=r(e,"P",{});var yp=n(sa);ki=p(yp,"Launch training with the following command:"),yp.forEach(t),xo=m(e),$(Ot.$$.fragment,e),Ao=m(e),ce=r(e,"H2",{class:!0});var rr=n(ce);Ve=r(rr,"A",{id:!0,class:!0,href:!0});var kp=n(Ve);is=r(kp,"SPAN",{});var Dp=n(is);$(Mt.$$.fragment,Dp),Dp.forEach(t),kp.forEach(t),Di=m(rr),ls=r(rr,"SPAN",{});var xp=n(ls);xi=p(xp,"Inference"),xp.forEach(t),rr.forEach(t),jo=m(e),Y=r(e,"P",{});var Qe=n(Y);Ai=p(Qe,"Once you have trained a model, specify the path to where the model is saved, and use it for inference in the "),oa=r(Qe,"A",{href:!0});var Ap=n(oa);ji=p(Ap,"StableDiffusionPipeline"),Ap.forEach(t),Pi=p(Qe,". Make sure your prompts include the special "),ps=r(Qe,"CODE",{});var jp=n(ps);Si=p(jp,"identifier"),jp.forEach(t),Ii=p(Qe," used during training ("),hs=r(Qe,"CODE",{});var Pp=n(hs);Ni=p(Pp,"sks"),Pp.forEach(t),Ti=p(Qe," in the previous examples)."),Qe.forEach(t),Po=m(e),He=r(e,"P",{});var nr=n(He);qi=p(nr,"If you have "),fs=r(nr,"STRONG",{});var Sp=n(fs);us=r(Sp,"CODE",{});var Ip=n(us);Ri=p(Ip,'"accelerate>=0.16.0"'),Ip.forEach(t),Sp.forEach(t),Ci=p(nr,` installed, you can use the following code to run
inference from an intermediate checkpoint:`),nr.forEach(t),So=m(e),$(Lt.$$.fragment,e),Io=m(e),Ye=r(e,"P",{});var ir=n(Ye);Ui=p(ir,"You may also run inference from any of the "),ra=r(ir,"A",{href:!0});var Np=n(ra);Oi=p(Np,"saved training checkpoints"),Np.forEach(t),Mi=p(ir,"."),ir.forEach(t),this.h()},h(){u(f,"name","hf:doc:metadata"),u(f,"content",JSON.stringify(ah)),u(d,"id","dreambooth"),u(d,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(d,"href","#dreambooth"),u(i,"class","relative group"),u(q,"href","https://arxiv.org/abs/2208.12242"),u(q,"rel","nofollow"),Op(L.src,D="https://dreambooth.github.io/DreamBooth_files/teaser_static.jpg")||u(L,"src",D),u(L,"alt","Dreambooth examples from the project's blog"),u(W,"href","https://dreambooth.github.io"),u(Xe,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),u(Xe,"rel","nofollow"),u(et,"href","https://github.com/huggingface/diffusers/tree/main/examples/dreambooth"),u(et,"rel","nofollow"),u(Vt,"href","../optimization/xformers"),u(at,"href","https://github.com/huggingface/accelerate/"),u(at,"rel","nofollow"),u(ge,"id","finetuning"),u(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ge,"href","#finetuning"),u(ee,"class","relative group"),u(be,"id","finetuning-with-priorpreserving-loss"),u(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(be,"href","#finetuning-with-priorpreserving-loss"),u(te,"class","relative group"),u(lt,"href","https://arxiv.org/abs/2208.12242"),u(lt,"rel","nofollow"),u(ke,"id","finetuning-the-text-encoder-and-unet"),u(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ke,"href","#finetuning-the-text-encoder-and-unet"),u(ae,"class","relative group"),u(ht,"href","https://huggingface.co/blog/dreambooth"),u(ht,"rel","nofollow"),u(Ae,"id","finetuning-with-lora"),u(Ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ae,"href","#finetuning-with-lora"),u(se,"class","relative group"),u(Wt,"href","training/lora#dreambooth"),u(Pe,"id","saving-checkpoints-while-training"),u(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Pe,"href","#saving-checkpoints-while-training"),u(oe,"class","relative group"),u(Se,"id","resume-training-from-a-saved-checkpoint"),u(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Se,"href","#resume-training-from-a-saved-checkpoint"),u(re,"class","relative group"),u(Ie,"id","inference-from-a-saved-checkpoint"),u(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ie,"href","#inference-from-a-saved-checkpoint"),u(ne,"class","relative group"),u(qe,"id","optimizations-for-different-gpu-sizes"),u(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(qe,"href","#optimizations-for-different-gpu-sizes"),u(ie,"class","relative group"),u(Re,"id","xformers"),u(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Re,"href","#xformers"),u(le,"class","relative group"),u(wt,"href","https://github.com/facebookresearch/xformers"),u(wt,"rel","nofollow"),u(Et,"href","https://facebookresearch.github.io/xformers/components/ops.html#module-xformers.ops"),u(Et,"rel","nofollow"),u(Xt,"href","./optimization/xformers"),u(Ce,"id","set-gradients-to-none"),u(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ce,"href","#set-gradients-to-none"),u(pe,"class","relative group"),u(Dt,"href","https://pytorch.org/docs/stable/generated/torch.optim.Optimizer.zero_grad.html"),u(Dt,"rel","nofollow"),u(Ue,"id","16gb-gpu"),u(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ue,"href","#16gb-gpu"),u(he,"class","relative group"),u(jt,"href","https://github.com/TimDettmers/bitsandbytes"),u(jt,"rel","nofollow"),u(Le,"id","12gb-gpu"),u(Le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Le,"href","#12gb-gpu"),u(fe,"class","relative group"),u(Ge,"id","8-gb-gpu"),u(Ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ge,"href","#8-gb-gpu"),u(ue,"class","relative group"),u(qt,"href","https://www.deepspeed.ai/"),u(qt,"rel","nofollow"),u(Ct,"href","https://huggingface.co/docs/accelerate/usage_guides/deepspeed"),u(Ct,"rel","nofollow"),u(Ut,"href","https://deepspeed.readthedocs.io/en/latest/optimizers.html#adam-cpu"),u(Ut,"rel","nofollow"),u(Ve,"id","inference"),u(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ve,"href","#inference"),u(ce,"class","relative group"),u(oa,"href","/docs/diffusers/pr_2759/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),u(ra,"href","#inference-from-a-saved-checkpoint")},m(e,s){a(document.head,f),h(e,_,s),h(e,i,s),a(i,d),a(d,k),v(j,k,null),a(i,I),a(i,C),a(C,z),h(e,N,s),v(R,e,s),h(e,T,s),h(e,U,s),a(U,q),a(q,O),a(U,G),h(e,y,s),h(e,x,s),a(x,L),h(e,S,s),h(e,Z,s),a(Z,Bt),a(Z,W),a(W,Ft),h(e,ds,s),h(e,K,s),a(K,lr),a(K,Xe),a(Xe,ua),a(ua,pr),a(K,hr),a(K,et),a(et,fr),a(K,ur),h(e,gs,s),h(e,me,s),a(me,cr),a(me,ca),a(ca,mr),a(me,_r),h(e,$s,s),v(tt,e,s),h(e,vs,s),h(e,_e,s),a(_e,dr),a(_e,Vt),a(Vt,gr),a(_e,$r),h(e,bs,s),h(e,de,s),a(de,vr),a(de,at),a(at,br),a(de,wr),h(e,ws,s),v(st,e,s),h(e,Es,s),h(e,Ht,s),a(Ht,Er),h(e,ys,s),v(ot,e,s),h(e,ks,s),h(e,Yt,s),a(Yt,yr),h(e,Ds,s),v(rt,e,s),h(e,xs,s),h(e,ee,s),a(ee,ge),a(ge,ma),v(nt,ma,null),a(ee,kr),a(ee,_a),a(_a,Dr),h(e,As,s),v($e,e,s),h(e,js,s),v(ve,e,s),h(e,Ps,s),h(e,te,s),a(te,be),a(be,da),v(it,da,null),a(te,xr),a(te,ga),a(ga,Ar),h(e,Ss,s),h(e,we,s),a(we,jr),a(we,lt),a(lt,Pr),a(we,Sr),h(e,Is,s),h(e,Ee,s),a(Ee,Ir),a(Ee,$a),a($a,Nr),a(Ee,Tr),h(e,Ns,s),v(ye,e,s),h(e,Ts,s),h(e,ae,s),a(ae,ke),a(ke,va),v(pt,va,null),a(ae,qr),a(ae,ba),a(ba,Rr),h(e,qs,s),h(e,B,s),a(B,Cr),a(B,wa),a(wa,Ur),a(B,Or),a(B,Ea),a(Ea,Mr),a(B,Lr),a(B,ht),a(ht,zr),a(B,Gr),h(e,Rs,s),v(De,e,s),h(e,Cs,s),h(e,F,s),a(F,Br),a(F,ya),a(ya,Fr),a(F,Vr),a(F,ka),a(ka,Hr),a(F,Yr),a(F,Da),a(Da,Wr),a(F,Jr),h(e,Us,s),v(xe,e,s),h(e,Os,s),h(e,se,s),a(se,Ae),a(Ae,xa),v(ft,xa,null),a(se,Zr),a(se,Aa),a(Aa,Kr),h(e,Ms,s),h(e,je,s),a(je,Qr),a(je,Wt),a(Wt,Xr),a(je,en),h(e,Ls,s),h(e,oe,s),a(oe,Pe),a(Pe,ja),v(ut,ja,null),a(oe,tn),a(oe,Pa),a(Pa,an),h(e,zs,s),h(e,Jt,s),a(Jt,sn),h(e,Gs,s),v(ct,e,s),h(e,Bs,s),h(e,V,s),a(V,on),a(V,Sa),a(Sa,rn),a(V,nn),a(V,Ia),a(Ia,ln),a(V,pn),a(V,Na),a(Na,hn),a(V,fn),h(e,Fs,s),h(e,re,s),a(re,Se),a(Se,Ta),v(mt,Ta,null),a(re,un),a(re,qa),a(qa,cn),h(e,Vs,s),h(e,Q,s),a(Q,mn),a(Q,Ra),a(Ra,_n),a(Q,dn),a(Q,Ca),a(Ca,gn),a(Q,$n),h(e,Hs,s),v(_t,e,s),h(e,Ys,s),h(e,Zt,s),a(Zt,vn),h(e,Ws,s),h(e,ne,s),a(ne,Ie),a(Ie,Ua),v(dt,Ua,null),a(ne,bn),a(ne,Oa),a(Oa,wn),h(e,Js,s),h(e,Kt,s),a(Kt,En),h(e,Zs,s),h(e,Ne,s),a(Ne,yn),a(Ne,Ma),a(Ma,La),a(La,kn),a(Ne,Dn),h(e,Ks,s),v(gt,e,s),h(e,Qs,s),h(e,Te,s),a(Te,xn),a(Te,za),a(za,Ga),a(Ga,An),a(Te,jn),h(e,Xs,s),v($t,e,s),h(e,eo,s),h(e,ie,s),a(ie,qe),a(qe,Ba),v(vt,Ba,null),a(ie,Pn),a(ie,Fa),a(Fa,Sn),h(e,to,s),h(e,Qt,s),a(Qt,In),h(e,ao,s),h(e,le,s),a(le,Re),a(Re,Va),v(bt,Va,null),a(le,Nn),a(le,Ha),a(Ha,Tn),h(e,so,s),h(e,J,s),a(J,wt),a(wt,qn),a(J,Rn),a(J,Et),a(Et,Cn),a(J,Un),a(J,Xt),a(Xt,On),a(J,Mn),h(e,oo,s),v(yt,e,s),h(e,ro,s),h(e,ea,s),a(ea,Ln),h(e,no,s),h(e,pe,s),a(pe,Ce),a(Ce,Ya),v(kt,Ya,null),a(pe,zn),a(pe,Wa),a(Wa,Gn),h(e,io,s),h(e,H,s),a(H,Bn),a(H,Dt),a(Dt,Fn),a(H,Vn),a(H,Ja),a(Ja,Hn),a(H,Yn),a(H,Za),a(Za,Wn),a(H,Jn),h(e,lo,s),v(xt,e,s),h(e,po,s),h(e,he,s),a(he,Ue),a(Ue,Ka),v(At,Ka,null),a(he,Zn),a(he,Qa),a(Qa,Kn),h(e,ho,s),h(e,Oe,s),a(Oe,Qn),a(Oe,jt),a(jt,Xn),a(Oe,ei),h(e,fo,s),v(Pt,e,s),h(e,uo,s),h(e,Me,s),a(Me,ti),a(Me,Xa),a(Xa,ai),a(Me,si),h(e,co,s),v(St,e,s),h(e,mo,s),h(e,fe,s),a(fe,Le),a(Le,es),v(It,es,null),a(fe,oi),a(fe,ts),a(ts,ri),h(e,_o,s),h(e,ze,s),a(ze,ni),a(ze,as),a(as,ii),a(ze,li),h(e,go,s),v(Nt,e,s),h(e,$o,s),h(e,ue,s),a(ue,Ge),a(Ge,ss),v(Tt,ss,null),a(ue,pi),a(ue,os),a(os,hi),h(e,vo,s),h(e,Be,s),a(Be,fi),a(Be,qt),a(qt,ui),a(Be,ci),h(e,bo,s),h(e,ta,s),a(ta,mi),h(e,wo,s),v(Rt,e,s),h(e,Eo,s),h(e,Fe,s),a(Fe,_i),a(Fe,Ct),a(Ct,di),a(Fe,gi),h(e,yo,s),h(e,X,s),a(X,$i),a(X,Ut),a(Ut,rs),a(rs,vi),a(X,bi),a(X,ns),a(ns,wi),a(X,Ei),h(e,ko,s),h(e,aa,s),a(aa,yi),h(e,Do,s),h(e,sa,s),a(sa,ki),h(e,xo,s),v(Ot,e,s),h(e,Ao,s),h(e,ce,s),a(ce,Ve),a(Ve,is),v(Mt,is,null),a(ce,Di),a(ce,ls),a(ls,xi),h(e,jo,s),h(e,Y,s),a(Y,Ai),a(Y,oa),a(oa,ji),a(Y,Pi),a(Y,ps),a(ps,Si),a(Y,Ii),a(Y,hs),a(hs,Ni),a(Y,Ti),h(e,Po,s),h(e,He,s),a(He,qi),a(He,fs),a(fs,us),a(us,Ri),a(He,Ci),h(e,So,s),v(Lt,e,s),h(e,Io,s),h(e,Ye,s),a(Ye,Ui),a(Ye,ra),a(ra,Oi),a(Ye,Mi),No=!0},p(e,[s]){const zt={};s&2&&(zt.$$scope={dirty:s,ctx:e}),$e.$set(zt);const cs={};s&2&&(cs.$$scope={dirty:s,ctx:e}),ve.$set(cs);const ms={};s&2&&(ms.$$scope={dirty:s,ctx:e}),ye.$set(ms);const _s={};s&2&&(_s.$$scope={dirty:s,ctx:e}),De.$set(_s);const na={};s&2&&(na.$$scope={dirty:s,ctx:e}),xe.$set(na)},i(e){No||(b(j.$$.fragment,e),b(R.$$.fragment,e),b(tt.$$.fragment,e),b(st.$$.fragment,e),b(ot.$$.fragment,e),b(rt.$$.fragment,e),b(nt.$$.fragment,e),b($e.$$.fragment,e),b(ve.$$.fragment,e),b(it.$$.fragment,e),b(ye.$$.fragment,e),b(pt.$$.fragment,e),b(De.$$.fragment,e),b(xe.$$.fragment,e),b(ft.$$.fragment,e),b(ut.$$.fragment,e),b(ct.$$.fragment,e),b(mt.$$.fragment,e),b(_t.$$.fragment,e),b(dt.$$.fragment,e),b(gt.$$.fragment,e),b($t.$$.fragment,e),b(vt.$$.fragment,e),b(bt.$$.fragment,e),b(yt.$$.fragment,e),b(kt.$$.fragment,e),b(xt.$$.fragment,e),b(At.$$.fragment,e),b(Pt.$$.fragment,e),b(St.$$.fragment,e),b(It.$$.fragment,e),b(Nt.$$.fragment,e),b(Tt.$$.fragment,e),b(Rt.$$.fragment,e),b(Ot.$$.fragment,e),b(Mt.$$.fragment,e),b(Lt.$$.fragment,e),No=!0)},o(e){w(j.$$.fragment,e),w(R.$$.fragment,e),w(tt.$$.fragment,e),w(st.$$.fragment,e),w(ot.$$.fragment,e),w(rt.$$.fragment,e),w(nt.$$.fragment,e),w($e.$$.fragment,e),w(ve.$$.fragment,e),w(it.$$.fragment,e),w(ye.$$.fragment,e),w(pt.$$.fragment,e),w(De.$$.fragment,e),w(xe.$$.fragment,e),w(ft.$$.fragment,e),w(ut.$$.fragment,e),w(ct.$$.fragment,e),w(mt.$$.fragment,e),w(_t.$$.fragment,e),w(dt.$$.fragment,e),w(gt.$$.fragment,e),w($t.$$.fragment,e),w(vt.$$.fragment,e),w(bt.$$.fragment,e),w(yt.$$.fragment,e),w(kt.$$.fragment,e),w(xt.$$.fragment,e),w(At.$$.fragment,e),w(Pt.$$.fragment,e),w(St.$$.fragment,e),w(It.$$.fragment,e),w(Nt.$$.fragment,e),w(Tt.$$.fragment,e),w(Rt.$$.fragment,e),w(Ot.$$.fragment,e),w(Mt.$$.fragment,e),w(Lt.$$.fragment,e),No=!1},d(e){t(f),e&&t(_),e&&t(i),E(j),e&&t(N),E(R,e),e&&t(T),e&&t(U),e&&t(y),e&&t(x),e&&t(S),e&&t(Z),e&&t(ds),e&&t(K),e&&t(gs),e&&t(me),e&&t($s),E(tt,e),e&&t(vs),e&&t(_e),e&&t(bs),e&&t(de),e&&t(ws),E(st,e),e&&t(Es),e&&t(Ht),e&&t(ys),E(ot,e),e&&t(ks),e&&t(Yt),e&&t(Ds),E(rt,e),e&&t(xs),e&&t(ee),E(nt),e&&t(As),E($e,e),e&&t(js),E(ve,e),e&&t(Ps),e&&t(te),E(it),e&&t(Ss),e&&t(we),e&&t(Is),e&&t(Ee),e&&t(Ns),E(ye,e),e&&t(Ts),e&&t(ae),E(pt),e&&t(qs),e&&t(B),e&&t(Rs),E(De,e),e&&t(Cs),e&&t(F),e&&t(Us),E(xe,e),e&&t(Os),e&&t(se),E(ft),e&&t(Ms),e&&t(je),e&&t(Ls),e&&t(oe),E(ut),e&&t(zs),e&&t(Jt),e&&t(Gs),E(ct,e),e&&t(Bs),e&&t(V),e&&t(Fs),e&&t(re),E(mt),e&&t(Vs),e&&t(Q),e&&t(Hs),E(_t,e),e&&t(Ys),e&&t(Zt),e&&t(Ws),e&&t(ne),E(dt),e&&t(Js),e&&t(Kt),e&&t(Zs),e&&t(Ne),e&&t(Ks),E(gt,e),e&&t(Qs),e&&t(Te),e&&t(Xs),E($t,e),e&&t(eo),e&&t(ie),E(vt),e&&t(to),e&&t(Qt),e&&t(ao),e&&t(le),E(bt),e&&t(so),e&&t(J),e&&t(oo),E(yt,e),e&&t(ro),e&&t(ea),e&&t(no),e&&t(pe),E(kt),e&&t(io),e&&t(H),e&&t(lo),E(xt,e),e&&t(po),e&&t(he),E(At),e&&t(ho),e&&t(Oe),e&&t(fo),E(Pt,e),e&&t(uo),e&&t(Me),e&&t(co),E(St,e),e&&t(mo),e&&t(fe),E(It),e&&t(_o),e&&t(ze),e&&t(go),E(Nt,e),e&&t($o),e&&t(ue),E(Tt),e&&t(vo),e&&t(Be),e&&t(bo),e&&t(ta),e&&t(wo),E(Rt,e),e&&t(Eo),e&&t(Fe),e&&t(yo),e&&t(X),e&&t(ko),e&&t(aa),e&&t(Do),e&&t(sa),e&&t(xo),E(Ot,e),e&&t(Ao),e&&t(ce),E(Mt),e&&t(jo),e&&t(Y),e&&t(Po),e&&t(He),e&&t(So),E(Lt,e),e&&t(Io),e&&t(Ye)}}}const ah={local:"dreambooth",sections:[{local:"finetuning",title:"Finetuning"},{local:"finetuning-with-priorpreserving-loss",title:"Finetuning with prior-preserving loss"},{local:"finetuning-the-text-encoder-and-unet",title:"Finetuning the text encoder and UNet"},{local:"finetuning-with-lora",title:"Finetuning with LoRA"},{local:"saving-checkpoints-while-training",sections:[{local:"resume-training-from-a-saved-checkpoint",title:"Resume training from a saved checkpoint"},{local:"inference-from-a-saved-checkpoint",title:"Inference from a saved checkpoint"}],title:"Saving checkpoints while training"},{local:"optimizations-for-different-gpu-sizes",sections:[{local:"xformers",title:"xFormers"},{local:"set-gradients-to-none",title:"Set gradients to none"},{local:"16gb-gpu",title:"16GB GPU"},{local:"12gb-gpu",title:"12GB GPU"},{local:"8-gb-gpu",title:"8 GB GPU"}],title:"Optimizations for different GPU sizes"},{local:"inference",title:"Inference"}],title:"DreamBooth"};function sh(A){return Mp(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class hh extends qp{constructor(f){super();Rp(this,f,sh,th,Cp,{})}}export{hh as default,ah as metadata};
